<?php

 session_start();

define("IPSET_LOCATION","/etc/dnsmasq.d/ipset-master.conf");
define("DNSMASQ_BINARY","/usr/sbin/dnsmasq");
define("SERVICE_COMMAND","/usr/sbin/service");
define("HEADING","Master IPSET Domain Assignment");
define("LOCATIONS_IPSETS",array("0"=>"/etc/iptables/ipset-dns.v4","1"=>"/etc/iptables/ipset-dns.v6"));



function getAvailableIPSets()
{
	$ipsets=array();

	for($i=0; $i<count(LOCATIONS_IPSETS) ;$i++)
	{
              if(!is_readable(LOCATIONS_IPSETS[$i]))
	      {
		      die("Cannot Read ipset ROOT Directory: ".LOCATIONS_IPSETS[$i]);
	      }

	      $elements=scandir(LOCATIONS_IPSETS[$i]);

	      for($j=0;$j<count($elements); $j++)
	      {
		      if($elements[$j]!="." && $elements[$j]!="..")
		      {
			      array_push($ipsets,$elements[$j]);
		      }
	      }


	}
	arsort($ipsets,SORT_STRING);

     return $ipsets;

}


function getTargets()
{

        $rows_content=file(IPSET_LOCATION);


        $targets=array();


        for($i=0; $i<count($rows_content) ; $i++)
        {
                $cols_targets=explode("/",$rows_content[$i]);

		#array_push($targets,$cols_targets[1]);
		$targets[$i]['target']=$cols_targets[1];
		
		$ipsets=array();

		for($j=2;$j<count($cols_targets) ;$j++)
		{
			$targets[$i]['ipsets'][$j-2]=trim($cols_targets[$j]);
		}


        }

        return $targets;
}

function checkConfig()
{

  if(!isset($_SERVER['PHP_AUTH_USER']))
  {

      die("No User Authentication sent. You must require htaccess Authentication");

  }


  if(! is_readable(IPSET_LOCATION))
       die("Cannot read IPSET_LOCATION please check");
  if(!is_writeable(IPSET_LOCATION))
       die("Cannot write IPSET_LOCATION please check");
   if(! is_readable(DNSMASQ_BINARY))
       die("Cannot read DNSMASQ binary");
   if(! is_readable(SERVICE_COMMAND))
       die("Cannot read SERVICE command");

}

function writeTargets($targets)
{

$ipsetString="";



for($i=0; $i<count($targets) ;$i++)
{
  if($targets[$i]!="TO_BE_DELETED")
  {
	 
	 $ipsetString.='ipset=/'.$targets[$i]['target'];

	 for($j=0; $j<count($targets[$i]['ipsets']) ;$j++)
	 {
		 $ipsetString.='/'.$targets[$i]['ipsets'][$j];
	 }
	 $ipsetString.="\n";

  }
}

return file_put_contents(IPSET_LOCATION,$ipsetString);

}

function restartDNSMASQ()
{


exec("sudo /usr/sbin/service dnsmasq restart",$output,$return_code);

return $return_code;

}


function checkAdd()
{

if(isset($_POST['add']) && isset($_POST['target_add']) && strlen($_POST['target_add'])>1 )
{

  $to_add=parse_url($_POST['target_add'],PHP_URL_HOST);

  if( $to_add===FALSE || !strlen($to_add))
  {

   $to_add="https://".$_POST['target_add'];
   
   $to_add=parse_url($to_add,PHP_URL_HOST);

  }



  if($to_add===FALSE || !strlen($to_add) )
  {

   echo "Please use different Method e.g. http://www.hotmail.com/ leads to www.hotmail.com";

  }
  else
  {


	$targets=getTargets();
        $targetFound=false;

	for($i=0; $i<count($targets)&& !$targetFound; $i++)
	{
		if($targets[$i]['target']==$to_add)
		{
			$targetFound=true;
		}
	}
	$i--;

        $posFound=$i;	


	        $chosen_ipsets=array();
		$i=0;
		$avail_ipsets=getAvailableIPSets();
		for($i=0 ; $i<count($avail_ipsets); $i++)
		{

			if(isset($_POST['avail_ipset'.$i]) && in_array($_POST['avail_ipset'.$i],$avail_ipsets) )
			{
				array_push($chosen_ipsets,$_POST['avail_ipset'.$i]);
			}
		
		}

		if(count($chosen_ipsets)>0)
		{
			$add_array=array();
			$add_array['target']=$to_add;
			$add_array['ipsets']=$chosen_ipsets;

			if($targetFound===true)
			{
				$targets[$posFound]['ipsets']=$add_array['ipsets'];
			}
			else
			{
			array_push($targets,$add_array);
			}

			if(writeTargets($targets)!==FALSE && restartDNSMASQ()==0)
			{
				if($targetFound===true)
				{
					 echo "Successfully changed ".$to_add;
				}
				else
				{

					echo "Successfully added ".$to_add;
				}

        		}
        		else
			{
				if($targetFound===true)
				{
					echo "Could not change ".$to_add;
				}
				else
				{
					echo "Could not add ".$to_add;
				}
        		}
    

		}
		else
		{
			echo "No Ipset has been selected";
		}


  }
}
}



function checkDelete()
{

if(isset($_POST['delete']) && isset($_POST['target_delete']))
{
   $to_delete=$_POST['target_delete'];

   $targets=getTargets();
   $found=false;
   for($i=0; $i<count($targets) && !$found; $i++)
   {
	   if($targets[$i]['target']==$to_delete)
	   {
		   $found=true;
	   }
   }
   $i--;

   if($found===true)
   {
      $pos=$i;

      $targets[$pos]="TO_BE_DELETED";

      /* Rebuild IPSET entries */

       if(writeTargets($targets)!==FALSE)
       {
             if(restartDNSMASQ()==0)
             {
                   echo "Successfully deleted $to_delete";
             }
             else
             {
                  echo "Couldn't restart DNSMASQ service";
             }
      
       }
       else
       {
         echo "Couldn't delete domain entry";
        }



   }
   else
   {
       echo "Cannot find $to_delete entry";
   }


}

}


function checkAction()
{

checkConfig();
checkDelete();
checkAdd();


}



?>


<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="">
    <meta name="author" content="Christian Czeczil">
    <link rel="icon" href="../../favicon.ico">

    <title><?php echo HEADING ?></title>

    <!-- Bootstrap core CSS -->
    <link href="bootstrap/css/bootstrap.min.css" rel="stylesheet">
    <!-- Bootstrap theme -->
    <link href="boostrap/css/bootstrap-theme.min.css" rel="stylesheet">
    <!-- IE10 viewport hack for Surface/desktop Windows 8 bug -->
    <link href="assets/css/ie10-viewport-bug-workaround.css" rel="stylesheet">

    <!-- Custom styles for this template -->
    <link href="theme.css" rel="stylesheet">


  </head>

  <body>



    <div class="container theme-showcase" role="main">

      <!-- Main jumbotron for a primary marketing message or call to action -->
      <div class="jumbotron">
        <h1><?php echo HEADING ?></h1>
      </div>

  <table class="table table-hover">
  <thead>
   <tr><th>Status</th></tr>
  </thead>
   <tr><td><?php checkAction(); ?></td></tr>
  </table>


<form action="<?php echo $SERVER['PHP_SELF']; ?>" method="POST">

   <table class="table table-hover">
  <thead>
   <tr><th>Hostnamen hinzufügen</th><th>Verfügbare IPSETs</th>
  </tr>
  </thead>
   <tr>
<td><input type="text" class="form-control" name="target_add"></td>

<?php

$available_ipsets=getAvailableIPSets();

for($i=0; $i<count($available_ipsets); $i++)
{

	
	echo '<td>';

	echo '<input type="checkbox" id="avail_ipset'.$i.'" value="'.$available_ipsets[$i].'" name="avail_ipset'.$i.'">';

        echo '<label>'.$available_ipsets[$i].'</label>';
        echo '</td>';
}

?>


</tr>


<tr><td><button type="submit" class="btn btn-default" name="add">Hinzufügen</button></td></tr>


 </table>

</form>


   <table class="table table-hover">
            <thead>
              <tr>
                <th>Domain</th>
		<th>Aktion</th>
		<th>IPSets</th>
              </tr>
            </thead>
            <tbody>

  <?php

$targets=getTargets();
$avail_ipsets=getAvailableIPSets();

        for($i=0; $i<count($targets) ;$i++)
        {
          $currentTarget=$targets[$i];
          echo '<tr>';

          echo "<td>".$currentTarget['target']."</td>";

          echo '<td>';
        
          echo '<form action="'.$_SERVER['PHP_SELF'].'" method="POST">';
	  echo '<input type="hidden" name="target_delete" value="'.$currentTarget['target'].'">';
	  echo '<input type="hidden" name="target_add" value="'.$currentTarget['target'].'">';
          echo '<button type="submit" class="btn btn-default" name="delete">Löschen</button><br/><button type="submit" class="btn btn-default" name="add">Ändern</button>';

	  echo '</td>';

         
	  for($j=0; $j<count($avail_ipsets); $j++)
	  {
	       echo '<td>';
	       $ipsetFound=false;
	       
	       if(in_array($avail_ipsets[$j],$currentTarget['ipsets'],true))
	       {
		       $ipsetFound=true;
	       }

	       if($ipsetFound===true)
	       {
		                     echo '<input type="checkbox" id="avail_ipset'.$j.'" value="'.$available_ipsets[$j].'" name="avail_ipset'.$j.'" checked>';
	       }
	       else
	       {
               echo '<input type="checkbox" id="avail_ipset'.$j.'" value="'.$available_ipsets[$j].'" name="avail_ipset'.$j.'">';
		}

        echo '<label>'.$avail_ipsets[$j].'</label>';



	       echo '</td>';


	  } 


               echo '</form>';
          echo '</tr>';


     }

 ?>

              </tbody>
          </table>
  
  </body>
</html>
